#!/bin/bash

single_dial() {
	pppd file /etc/ppp/options.prfile
}

multi_dial() {
	n=0
	files=/etc/route/account_list.txt
	while read line; do
		netcard=` echo $line | awk '{print $3}' `
		ip link add link $netcard name veth$n type macvlan
		ip link set veth$n up
		pppd file /etc/ppp/options.prfile$n
		sleep 2
		let n+=1
	done < $files
	/root/pear/tools/post.sh
}

multi_dial_multiwan() {
	n=0
	files=/etc/route/account_list_multiwan.txt
	while read line; do
		netcard=` echo $line | awk '{print $3}' `
		ip link add link $netcard name veth$n type macvlan
		ip link set veth$n up
		pppd file /etc/ppp/options.prfile$n
		sleep 2
		let n+=1
	done < $files
	/root/pear/tools/post.sh
}

network_dynamic() {

}

network_static() {
	netcard=`cat /etc/route/pppoe_single.json | jq -r .nic_name`
	addr=`cat /etc/route/network_static.json | jq -r .ip_addr`
	mask=`cat /etc/route/network_static.json | jq -r .netmask`
	gateway=`cat /etc/route/network_static.json | jq -r .gateway`
	ifconfig ${netcard} ${addr} netmask ${mask}
	ip route del default
	ip route add default via ${gateway} dev ${netcard}
}

network_bridge() {

}

ps -ef | grep -v grep | grep prfile | awk '{system("kill -9 " $2)}'
sleep 5

mode=`cat network_mode.json | jq -r .connect_type`
case "${mode}" in
  1)
    single_dial
    ;;
  2)
    multi_dial
    ;;
  3)
    multi_dial_multiwan
    ;;
  4)
    network_dynamic
    ;;
  5)
    network_static
    ;;
  6)
    network_bridge
    ;;
  *)
    exit 1
esac
