#!/bin/bash

cfgfile=/etc/router/config/storage_create_pool.json

raid_level=`cat ${cfgfile} | jq -r .raid_level`
disk_num=`cat ${cfgfile} | jq -r .drive_num`
disk_list=
raid_dev=
for i in $(seq 0 $[$disk_num-1])
do
	disk=`cat ${cfgfile} | jq -r .drives[$i]`
	disk_list=${disk_list}" "${disk}1
done

# get an unused raid device name
for i in $(seq 0 99)
do
	tmp_dev="/dev/md"$i
	if [[ ! -b ${tmp_dev} ]]; then
		raid_dev=${tmp_dev}
		break
	fi
done
if [[ -z ${raid_dev} ]]; then
	echo "Could not find unused raiddev..." >&2
	exit 1
fi

# clear disk part
for i in $(seq 0 $[$disk_num-1])
do
	disk=`cat ${cfgfile} | jq -r .drives[$i]`
	# parted disk
	parted -s ${disk} mklabel gpt mkpart primary 0% 100%
	sleep 1
	# clear disk raid info
	diskdev=${disk}1
	old_type=`lsblk -no fstype ${diskdev} | head -1`
	if [[ ${old_type} == linux_raid_member ]]; then
		mddev=`cat /proc/mdstat | grep ${diskdev:5} | awk '{print $1}'`
		if [[ -n ${mddev} ]]; then
			mdadm -S ${mddev}
			mdadm --zero-superblock ${diskdev}
			sleep 1
		fi
		old_type=`lsblk -no fstype ${diskdev} | head -1`
		if [[ ${old_type} == linux_raid_member ]]; then
			echo "data disk clean superblock fail..." >&2
			exit 1
		fi
		parted -s ${disk} mklabel gpt mkpart primary 0% 100%
		sleep 1
	fi
	parted -s ${disk} set 1 raid on
done
sleep 0.5

# create new raid
mdadm -C ${raid_dev} -l ${raid_level} -n ${disk_num} ${disk_list} << EOF
y
EOF
sleep 1
