local cjson = require("cjson")
local ret = io.popen('ls /sys/class/net/ | grep -v "$(ls /sys/devices/virtual/net/)"')
local net_list = {}
setmetatable(net_list, cjson.empty_array_mt)
local net_5g_list = {}
setmetatable(net_5g_list, cjson.empty_array_mt)
for ifname in ret:lines()
do
	local dir_name = "/sys/class/net/"..ifname.."/wireless"
	local file = io.open(dir_name, "r");
	if (file ~= nil) then
		local mac_file = io.popen("cat /sys/class/net/"..ifname.."/address | awk -F: '{print $5 $6}' | tr -d '\n'")
		local mac = mac_file:read("*a")
		mac_file:close()
		local info = {}
		info["ifname"] = ifname
		info["ssid"] = "PearBox-"..mac
		local os_ret = os.execute("iwlist "..ifname.." channel | grep 'Channel 36'")
		if (os_ret == nil) then
			table.insert(net_list, info)
		else
			table.insert(net_5g_list, info)
		end
	end
end

local temp = {}
local os_ret = os.execute("ip addr show dev eth0 | grep dynamic")
if (os_ret == nil) then
	temp["setup"] = 1
else
	temp["setup"] = 4
end
temp["wireless_2g"] = net_list
temp["wireless_5g"] = net_5g_list
local resp = cjson.encode(temp)
ngx.say(resp)
