local router = require("router")
local cjson = require("cjson")

local file = io.open("/etc/router/config/user_info.json", "r");
if (file == nil) then
	router.process_error(1, "user_login: open file failed!")
	return
end
local file_data = file:read("*a");
file:close()

local user = cjson.decode(file_data)
local res = ngx.location.capture("/kodlogin", {
	method = ngx.HTTP_GET,
	args = {name=user["username"], password=user["password"]}
});
if (200 ~= res.status) then
	router.process_error(1, "user name or password is incorrect!")
	return -1
end
local res_body_data = cjson.decode(res.body)
if (res_body_data["code"] == false) then
	router.process_error(1, "user name or password is incorrect!")
	return -1
end

local token = res_body_data["info"]
local body_data = ngx.req.get_body_data()
local req = cjson.decode(body_data)
res = ngx.location.capture("/koduser",{
	method = ngx.HTTP_POST,
	args = {name=req["username"], password=req["password"], accessToken=token}
});
if (200 ~= res.status) then
	router.process_error(1, "Route-Token is invalid!")
	return -1
end
res_body_data = cjson.decode(res.body)
if (res_body_data["code"] ~= true) then
	router.process_error(1, "user name or password is incorrect!")
	return -1
end

router.write_config("/etc/router/config/user_info.json", "echo 'init user success!'")
